(defun C:DELETE (/ ss1 len ind ent)
  (edsv)
  (setq ss1 (ssget)
        len (sslength ss1)
        ind 0)
  (if (= #elst# nil)
    (setq #elst# ())
    (setq #elst# (reverse #elst#))
  )
  (while (<= ind (1- len))
    (setq ent (ssname ss1 ind))
    (if (not (member ent #elst#))
      (setq #elst# (cons (list ent) #elst#))
    )
    (setq ind (1+ ind))
    (entdel ent)
  )
  (setq #elst# (reverse #elst#))
  (edrv)
  (princ)
)
(defun C:UNDEL (/ ind tone tlst ttwo)
  (edsv)
  (if (= 0 (length #elst#))(alert "\nNothing to undelete!")
    (progn
      (prompt (strcat "\nThere are "(itoa (length #elst#))" Erased elements listed."))
      (setq #elst# (reverse #elst#)
            ind 0)
      (grclear)
      (repeat (length #elst#)
        (entdel (car (nth ind #elst#)))
        (redraw (car (nth ind #elst#)) 4)
        (if (= nil #ans)(setq #ans "Y"))
        (setq #ans (strcase (ukword 1 "Y N" "\nUndelete this entity? N/<Y>" #ans)))
        (if (= #ans "Y")
          (progn
            (if (= (length #elst#) 1)(setq #elst# nil))
            (if (= (length #elst#) 2)(setq #elst# (member (nth 1 #elst#) #elst#)))
            (if (> (length #elst#) 2)
              (if (= 0 ind)
                (setq #elst# (member (nth 1 #elst#) #elst#))
                (progn
                  (setq tone (member (nth (1+ ind) #elst#) #elst#)
                        tlst (reverse #elst#)
                        ttwo (reverse (member (nth (- (length tlst) ind) tlst) tlst))
                        #elst# (append tone ttwo)
                  )
                )
              )
            )
          )
          (progn
            (entdel (car (nth ind #elst#)))
            (setq ind (1+ ind))
          )
        )
      )
      (redraw)
      (setq #elst# (reverse #elst#))
    )
  
  )
  (edrv)
  (princ)
)
(defun ukword (bit kwrd msg def / inp)
  (if (and def (/= def ""))
    (setq msg (strcat "\n" msg "<" def ">: ")
          bit (* 2 (fix (/ bit 2)))
    )
    (if (= " " (substr msg (strlen msg) 1))
      (setq msg (strcat "\n" (substr msg 1 (1- (strlen msg))) ": "))
      (setq msg (strcat "\n" msg ": "))
  ) )
  (initget bit kwrd)
  (setq inp (getkword msg))
  (if inp inp def)
)
(defun edsv ()
  (setq bm (getvar "blipmode"))
  (setq ce (getvar "cmdecho"))
  (setq oe *error* *error* ederr)
  (setvar "blipmode" 0)
  (setvar "cmdecho" 0)
  (command ".UNDO" "M")
  (graphscr)
)
(defun edrv ()
  (setvar "blipmode" bm)
  (setvar "cmdecho" ce)
  (setq *error* oe oe nil)
  (prompt "\nDone...  (C) Copyright 1995 - Wil_soft Development")
  (prompt "\n                  All Rights Reserved")(princ)
)
(defun ederr (s)
 (if (/= s "Function Cancelled")
   (princ (strcat "\nError: " s))
 )
 (setvar "blipmode" bm)
 (setvar "cmdecho" ce)
 (graphscr)
 (setq *error* oe oe nil)
 (princ)
)
(princ)
